! ======================================================================
! Rotacion real plana de Givens

! Datos: a, b
! Calculos:
!   sigma = SIGNO(a) (si |a|>|b|), SIGNO(b) (si |a|<=|b|)
!   d = sigma*SQRT(a**2+b**2)
!   c = a/d (si d/=0), 1 (si d=0)
!   s = b/d (si d/=0), 0 (si d=0)
!   z = s (si |s|<c o c=0), 1/c (si 0<|c|<=s)
! En salida a queda sustituida por d y b por z
! ======================================================================

PROGRAM drotg_Givens
IMPLICIT NONE

INTEGER, PARAMETER:: nsal=11
REAL(KIND(0.d0)):: a, b, c, s

OPEN (nsal,FILE='DROTG.sal')

a = -3.d300 ; b = 4.d300
CALL drotg (a, b, c, s)
WRITE (nsal,'(A,G25.16)') 'a = ', a, 'b = ', b, 'c = ', c, 's = ', s

WRITE (nsal,*)
a = 6.d0 ; b = -8.d0
CALL drotg (a, b, c, s)
WRITE (nsal,'(A,F25.16)') 'a = ', a, 'b = ', b, 'c = ', c, 's = ', s

ENDPROGRAM drotg_Givens