! ======================================================================
! Suma de los valores absolutos de las partes real e imaginaria de los
! elementos de un vector complejo

! Dato: z(1:n), z(j) = CMPLX(pr(j),pi(j))
! Calculo: s = SUM (ABS(pr(j))+ABS(pi(j)),j=1:n)

! ======================================================================
 
PROGRAM blas1_DZASUM
IMPLICIT NONE

INTEGER, PARAMETER:: n=4, nsal=11
COMPLEX(KIND(0.d0)) x(n)
REAL(KIND(0.d0)):: sumaf90, sumaDZASUM
REAL(KIND(0.d0)):: DZASUM

OPEN (nsal,FILE='BLAS4-DZASUM.sal')

x = (/ (1.2d0,3.8d0), (1.2d0,-3.8d0), (-1.2d0,3.8d0), (-1.2d0,-3.8d0) /)  

sumaf90 = SUM (ABS(REAL(x)) + ABS(AIMAG(x)))
sumaDZASUM = DZASUM(n,x,1)

WRITE (nsal,'(/(A,G25.17))') 'sumaf90    = ', sumaf90,                    &
   'sumaDZASUM = ', sumaDZASUM

ENDPROGRAM blas1_DZASUM      
