! ======================================================================
! Minimos cuadrados lineales. Nube en R2
! ======================================================================

PROGRAM mincua_1_lapack
IMPLICIT NONE

INTEGER, PARAMETER:: m=15, n=2, lw=1000, nsal=11
REAL(KIND(0.d0)):: t(m), y(m), a(m,n), b(m,1), w(lw), res(m)
INTEGER i, info
CHARACTER trans

! Primera sentencia ejecutable
! ----------------------------

OPEN (nsal,FILE='MINCUA-1-lapack.sal')

! Nube de puntos

t = (/ (1.d0*i, i=1,m) /)
y = (/ 7.d0,5.d0,8.d0,11.d0,11.d0, 10.d0,8.d0,11.d0,12.d0,10.d0,        &
       4.d0,9.d0,8.d0,5.d0,9.d0 /)
a(:,1) = 1.d0 ; a(:,2) = t ; b(:,1) = y

WRITE (nsal,'(A/(A,T7,15I5,2(/A,T8,15F5.0)))') 'Nube de puntos: ',      &
      'i =', (i,i=1,m), 't(i)=', t, 'y(i)=', y

WRITE (nsal,'(/A/16("="))') 'Calculos con DGELS (LAPACK)'

! DGELS. Solucion de minimos cuadrados de Ax=b

trans = 'N'
CALL dgels (trans, m, n, 1, a, m, b, m, w, lw, info)

WRITE (nsal,'(/A/9("-")/A,I2/A,(T15,A,F20.16))') 'DGELS', 'info =',     &
       info, 'Solucion: ', 'x1 = ', b(1,1), 'x2 = ', b(2,1)
a(:,1) = 1.d0 ; a(:,2) = t 
res = y(1:m) - MATMUL(a,b(1:n,1))
WRITE (nsal,'(/A,F20.16)') 'Suma de cuadrados de residuales = ',        &
       DOT_PRODUCT(res,res)

ENDPROGRAM mincua_1_lapack